Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr.instruct
Class TraceExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.instruct.Instruction
              net.sf.saxon.expr.instruct.TraceExpression

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, InstructionInfo, Locator

    public class TraceExpression

extends Instruction
implements InstructionInfo

A wrapper expression used to trace expressions in XPath and XQuery.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`TraceExpression(Expression child)` Create a trace expression that traces execution of a given child expression

Method Summary
`void` | `checkForUpdatingSubexpressions()` Check to ensure that this expression does not contain any inappropriate updating subexpressions.
`int` | `computeDependencies()` Get the static properties of this expression (other than its type).
`Expression` | `copy()` Copy an expression.
`boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
`Item` | `evaluateItem(XPathContext context)` Evaluate an expression as a single item.
`void` | `evaluatePendingUpdates(XPathContext context, PendingUpdateList pul)` Evaluate an updating expression, adding the results to a Pending Update List.
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`int` | `getCardinality()` Determine the static cardinality of the expression.
`Expression` | `getChildExpression()`
`int` | `getColumnNumber(long locationId)` Get the column number within the document, entity, or module containing a particular location
`int` | `getConstructType()` Get the construct type.
`int` | `getDependencies()` Determine which aspects of the context the expression depends on.
`int` | `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`InstructionInfo` | `getInstructionInfo()` Get the InstructionInfo details about the construct.
`int` | `getInstructionNameCode()` Get the namecode of the instruction for use in diagnostics
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
`int` | `getLineNumber(long locationId)` Get the line number of the expression being traced.
`NamespaceResolver` | `getNamespaceResolver()` Get the namespace resolver to supply the namespace context of the instruction that is being traced
`StructuredQName` | `getObjectName()` Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
`Iterator<String>` | `getProperties()` Get an iterator over all the properties available.
`Object` | `getProperty(String name)` Get a named property of the instruction/expression
`String` | `getSystemId(long locationId)` Get the system identifier (that is the base URI) of the static context of the expression being traced.
`boolean` | `isUpdatingExpression()` Determine whether this is an updating expression as defined in the XQuery update specification
`boolean` | `isVacuousExpression()` Determine whether this is a vacuous expression as defined in the XQuery update specification
`SequenceIterator<Item>` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
`Iterator<Expression>` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`TailCall` | `processLeavingTail(XPathContext context)` Execute this instruction, with the possibility of returning tail calls if there are any.
`Expression` | `promote(PromotionOffer offer, Expression parent)` Offer promotion for this subexpression.
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` | `setConstructType(int type)` Set the type of construct.
`void` | `setNamespaceResolver(NamespaceResolver resolver)` Set the namespace context for the instruction being traced.
`void` | `setObjectName(StructuredQName qName)` Set a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
`void` | `setProperty(String name, Object value)` Set a named property of the instruction/expression
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
`Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.expr.instruct.Instruction
`assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, dynamicError, evaluateAsString, getExpressionName, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, process, promoteInst`

Methods inherited from class net.sf.saxon.expr.Expression
`addToPathMap, adoptChildExpression, checkPermittedContents, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, explain, getColumnNumber, getContainer, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasLoopingSubexpression, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toString, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface net.sf.saxon.trace.InstructionInfo
`getLineNumber, getSystemId`

Methods inherited from interface org.xml.sax.Locator
`getColumnNumber, getPublicId`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getPublicId`

Constructor Detail

### TraceExpression

    public TraceExpression(Expression child)

  Create a trace expression that traces execution of a given child expression

  Parameters:
    `child` - the expression to be traced. This will be available to the TraceListener as the value of the "expression" property of the InstructionInfo.

Method Detail

### setConstructType

    public void setConstructType(int type)

  Set the type of construct. This will generally be a constant in class `Location`

  Parameters:
    `type` - an integer code for the type of construct being traced

### getConstructType

    public int getConstructType()

  Get the construct type. This will generally be a constant in class `Location`

  Specified by:
    `getConstructType` in interface `InstructionInfo`
  Overrides:
    `getConstructType` in class `Instruction`
  Returns:
    the type of expression, as enumerated in class `Location`

### setNamespaceResolver

    public void setNamespaceResolver(NamespaceResolver resolver)

  Set the namespace context for the instruction being traced. This is needed if the tracelistener wants to evaluate XPath expressions in the context of the current instruction

  Parameters:
    `resolver` - The namespace resolver, or null if none is needed

### getNamespaceResolver

    public NamespaceResolver getNamespaceResolver()

  Get the namespace resolver to supply the namespace context of the instruction that is being traced

  Returns:
    the namespace resolver, or null if none is in use

### setObjectName

    public void setObjectName(StructuredQName qName)

  Set a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.

  Parameters:
    `qName` - the name of the object, or null if not applicable

### getObjectName

    public StructuredQName getObjectName()

  Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.

  Specified by:
    `getObjectName` in interface `InstructionInfo`
  Overrides:
    `getObjectName` in class `Expression`
  Returns:
    the name of the object, or null if not applicable

### setProperty

    public void setProperty(String name,
                            Object value)

  Set a named property of the instruction/expression

  Parameters:
    `name` - the name of the property
    `value` - the value of the property

### getProperty

    public Object getProperty(String name)

  Get a named property of the instruction/expression

  Specified by:
    `getProperty` in interface `InstructionInfo`
  Overrides:
    `getProperty` in class `Expression`
  Parameters:
    `name` - the name of the property
  Returns:
    the value of the property

### getProperties

    public Iterator<String> getProperties()

  Get an iterator over all the properties available. The values returned by the iterator will be of type String, and each string can be supplied as input to the getProperty() method to retrieve the value of the property.

  Specified by:
    `getProperties` in interface `InstructionInfo`
  Overrides:
    `getProperties` in class `Expression`
  Returns:
    an iterator over the properties.

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Get the InstructionInfo details about the construct. This is to satisfy the InstructionInfoProvider interface.

  Returns:
    the instruction details

### getSystemId

    public String getSystemId(long locationId)

  Get the system identifier (that is the base URI) of the static context of the expression being traced. This returns the same result as getSystemId(), it is provided to satisfy the `LocationProvider` interface.

  Specified by:
    `getSystemId` in interface `LocationProvider`
  Overrides:
    `getSystemId` in class `Expression`
  Parameters:
    `locationId` - not used
  Returns:
    the URI of the module containing the expression

### getLineNumber

    public int getLineNumber(long locationId)

  Get the line number of the expression being traced. This returns the same result as getLineNumber(), it is provided to satisfy the `LocationProvider` interface.

  Specified by:
    `getLineNumber` in interface `LocationProvider`
  Overrides:
    `getLineNumber` in class `Expression`
  Parameters:
    `locationId` - not used
  Returns:
    the line number of the expression within its module

### getColumnNumber

    public int getColumnNumber(long locationId)

  Description copied from interface: `LocationProvider`
  Get the column number within the document, entity, or module containing a particular location

  Specified by:
    `getColumnNumber` in interface `LocationProvider`
  Overrides:
    `getColumnNumber` in class `Expression`
  Parameters:
    `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
  Returns:
    the column number within the document, entity, or module, or -1 if this is not available

### copy

    public Expression copy()

  Description copied from class: `Expression`
  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### isUpdatingExpression

    public boolean isUpdatingExpression()

  Determine whether this is an updating expression as defined in the XQuery update specification

  Overrides:
    `isUpdatingExpression` in class `Expression`
  Returns:
    true if this is an updating expression

### isVacuousExpression

    public boolean isVacuousExpression()

  Determine whether this is a vacuous expression as defined in the XQuery update specification

  Overrides:
    `isVacuousExpression` in class `Expression`
  Returns:
    true if this expression is vacuous

### checkForUpdatingSubexpressions

    public void checkForUpdatingSubexpressions()
                                        throws XPathException

  Check to ensure that this expression does not contain any inappropriate updating subexpressions. This check is overridden for those expressions that permit updating subexpressions.

  Overrides:
    `checkForUpdatingSubexpressions` in class `Expression`
  Throws:
    `XPathException` - if the expression has a non-permitted updating subexpression

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Specified by:
    `simplify` in class `Instruction`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ExpressionVisitor.ContextItemType contextItemType)
                         throws XPathException

  Description copied from class: `Expression`
  Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### getImplementationMethod

    public int getImplementationMethod()

  Description copied from class: `Instruction`
  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is prefered. For instructions this is the process() method.

  Overrides:
    `getImplementationMethod` in class `Instruction`
  Returns:
    the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

### promote

    public Expression promote(PromotionOffer offer,
                              Expression parent)
                       throws XPathException

  Offer promotion for this subexpression. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. This method is always called at compile time.

  Overrides:
    `promote` in class `Instruction`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
    `parent` - the parent of the subexpression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Execute this instruction, with the possibility of returning tail calls if there are any. This outputs the trace information via the registered TraceListener, and invokes the instruction being traced.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - the dynamic execution context
  Returns:
    either null, or a tail call that the caller must invoke on return
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the item type of the items returned by evaluating this instruction

  Overrides:
    `getItemType` in class `Instruction`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Overrides:
    `getCardinality` in class `Expression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### getDependencies

    public int getDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as `StaticProperty.DEPENDS_ON_CONTEXT_ITEM` and `StaticProperty.DEPENDS_ON_CURRENT_ITEM`. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.

  Overrides:
    `getDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the dependencies of the expression

### createsNewNodes

    public final boolean createsNewNodes()

  Determine whether this instruction creates new nodes.

  Overrides:
    `createsNewNodes` in class `Instruction`
  Returns:
    true if the instruction creates new nodes (or if it can't be proved that it doesn't)

### computeDependencies

    public int computeDependencies()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeDependencies` in class `Expression`
  Returns:
    a set of flags indicating static properties of this expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate an expression as a single item. This always returns either a single Item or null (denoting the empty sequence). No conversion is done. This method should not be used unless the static type of the expression is a subtype of "item" or "item?": that is, it should not be called if the expression may return a sequence. There is no guarantee that this condition will be detected.

  Overrides:
    `evaluateItem` in class `Instruction`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### iterate

    public SequenceIterator<Item> iterate(XPathContext context)
                                   throws XPathException

  Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.

  Overrides:
    `iterate` in class `Instruction`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### iterateSubExpressions

    public Iterator<Expression> iterateSubExpressions()

  Description copied from class: `Expression`
  Get the immediate sub-expressions of this expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### getChildExpression

    public Expression getChildExpression()

### getInstructionNameCode

    public int getInstructionNameCode()

  Description copied from class: `Instruction`
  Get the namecode of the instruction for use in diagnostics

  Overrides:
    `getInstructionNameCode` in class `Instruction`
  Returns:
    a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

### evaluatePendingUpdates

    public void evaluatePendingUpdates(XPathContext context,
                                       PendingUpdateList pul)
                                throws XPathException

  Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException

  Overrides:
    `evaluatePendingUpdates` in class `Expression`
  Parameters:
    `context` - the XPath dynamic evaluation context
    `pul` - the pending update list to which the results should be written
  Throws:
    `XPathException` - if evaluation fails

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.